
/* This work is copyrighted. See COPYRIGHT.OLD & COPYRIGHT.NEW for   *
*  details. If they are missing then this copy is in violation of    *
*  the copyright conditions.                                        */

/*
**	lib_tstp.c
**
**	The routine tstp().
**
*/

#include "terminfo.h"
#include "curses.h"
#include "curses.priv.h"
#include <signal.h>

static void cont(int);
static int creceived;

void tstp()
{
#ifdef _POSIX_SOURCE
struct sigaction act, oact;
#endif

#ifdef TRACE
	if (_tracing)
	    _tracef("tstp() called");
#endif

	endwin();

#ifdef _POSIX_SOURCE
	sigprocmask(0, NULL, &act.sa_mask);
	act.sa_handler = cont;
	act.sa_flags = 0;
	sigaction(SIGCONT, &act, &oact);
	sigdelset(&act.sa_mask, SIGCONT);
	creceived = 0;
	while (!creceived)
		sigsuspend(&act.sa_mask);
	sigaction(SIGCONT, &oact, NULL);

#else /* No POSIX */	
	{
	    struct sigvec sv = {0}, osv = {0};
	    int omask = sigblock (0);

	    sv.sv_handler = cont;
	    sv.sv_mask = omask;
	    sigvec (SIGCONT, &sv, &osv);
	    omask=sigblock (sigmask(SIGCONT));

	    creceived = 0;

	    kill (0, SIGSTOP);
/*********
            Without the kill(), we don't get a correct suspension
	    in case of ^Z. I don't know if there is a better way ....
	    (Changed for NeXT)
**********/		
	    
	    while (!creceived)
		sigpause (omask);
	    sigsetmask (omask);
	    sigvec (SIGCONT, &osv, NULL);
	}
#endif

	reset_prog_mode();
	flushinp();
	tputs(enter_ca_mode, 1, _outc);
	wrefresh(curscr);
}


static void cont(int signo)
{
	creceived = 1;
}
